// -------------------------------------------------------------------------------
// 
// 		cwCuA[JCo
// 
//	Creator			: Rc I
//	Creation Date	: 2003/09/11
//	Version			: 1.02
//
// -------------------------------------------------------------------------------

// dCN[hh~p`
#ifndef __DXARCHIVE
#define __DXARCHIVE

// include --------------------------------------
#include <stdio.h>

// define ---------------------------------------

// f[^^`
#ifndef u64
#define u64		unsigned __int64
#endif

#ifndef u32
#define u32		unsigned int
#endif

#ifndef u16
#define u16		unsigned short
#endif

#ifndef u8
#define u8		unsigned char
#endif

#ifndef s64
#define s64		signed __int64
#endif

#ifndef s32
#define s32		signed int
#endif

#ifndef s16
#define s16		signed short
#endif

#ifndef s8
#define s8		signed char
#endif

#ifndef f64
#define f64		double
#endif

#ifndef TRUE
#define TRUE	(1)
#endif

#ifndef FALSE
#define FALSE	(0)
#endif

#ifndef NULL
#define NULL	(0)
#endif

#define DXA_HEAD			*((u16 *)"DX")	// wb_
#define DXA_VER				(0x0006)		// o[W
#define DXA_BUFFERSIZE		(0x1000000)		// A[JCu쐬Ɏgpobt@̃TCY
#define DXA_KEYSTR_LENGTH	(12)			// ̒

/*
	o[WƂ̈Ⴂ

	0x0002 DARC_FILEHEAD  PressDataSize ǉ
	0x0004 DARC_HEAD  CodePage ǉ
	0x0005 ÍꕔύX
	0x0006 64bit
*/

/*
	f[^}bv
		
	DARC_HEAD
	t@Cf[^
	t@Ce[u
	DARC_FILEHEAD e[u
	DARC_DIRECTORY e[u
*/

/*
	t@C̃f[^`
	2byte:̒(oCgTCYS)
	2byte:̃peBf[^(SĂ̒̕l𑫂)
	p͑啶ɕϊꂽt@C̃f[^(S̔{̃TCY)
	p啶ɕϊĂȂt@C̃f[^
*/

// struct ---------------------------------------

#pragma pack(push)
#pragma pack(1)

// A[JCuf[^̍ŏ̃wb_
typedef struct tagDARC_HEAD
{
	u16 Head ;								// wb_
	u16 Version ;							// o[W
	u32 HeadSize ;							// wb_ DARC_HEAD 𔲂STCY
	u64 DataStartAddress ;					// ŏ̃t@C̃f[^i[Ăf[^AhX(t@C̐擪AhXAhXOƂ)
	u64 FileNameTableStartAddress ;			// t@Ce[u̐擪AhX(t@C̐擪AhXAhXOƂ)
	u64 FileTableStartAddress ;				// t@Ce[u̐擪AhX(oϐ FileNameTableStartAddress ̃AhXOƂ)
	u64 DirectoryTableStartAddress ;		// fBNge[u̐擪AhX(oϐ FileNameTableStartAddress ̃AhXOƂ)
											// AhXOzuĂ DARC_DIRECTORY \̂[gfBNg
	u64 CodePage ;							// t@CɎgpĂR[hy[Wԍ
} DARC_HEAD ;

// t@C̎ԏ
typedef struct tagDARC_FILETIME
{
	u64 Create ;			// 쐬
	u64 LastAccess ;		// ŏIANZX
	u64 LastWrite ;			// ŏIXV
} DARC_FILETIME ;

// t@Ci[
typedef struct tagDARC_FILEHEAD
{
	u64 NameAddress ;			// t@Ci[ĂAhX( ARCHIVE_HEAD\ ̃oϐ FileNameTableStartAddress ̃AhXAhXOƂ) 

	u64 Attributes ;			// t@C
	DARC_FILETIME Time ;		// ԏ
	u64 DataAddress ;			// t@Ci[ĂAhX
								//			t@C̏ꍇFDARC_HEAD\ ̃oϐ DataStartAddress AhXAhXOƂ
								//			fBNg̏ꍇFDARC_HEAD\ ̃oϐ DirectoryTableStartAddress ̂AhXAhXOƂ
	u64 DataSize ;				// t@C̃f[^TCY
	u64 PressDataSize ;			// k̃f[^̃TCY( 0xffffffffffffffff:kĂȂ ) ( Ver0x0002 Œǉꂽ )
} DARC_FILEHEAD ;

// fBNgi[
typedef struct tagDARC_DIRECTORY
{
	u64 DirectoryAddress ;			//  DARC_FILEHEAD i[ĂAhX( DARC_HEAD \ ̃oϐ FileTableStartAddress AhXAhXOƂ)
	u64 ParentDirectoryAddress ;	// efBNg DARC_DIRECTORY i[ĂAhX( DARC_HEAD\ ̃oϐ DirectoryTableStartAddress AhXAhXOƂ)
	u64 FileHeadNum ;				// fBNg̃t@C̐
	u64 FileHeadAddress ;			// fBNg̃t@C̃wb_񂪊i[ĂAhX( DARC_HEAD\ ̃oϐ FileTableStartAddress AhXAhXOƂ) 
} DARC_DIRECTORY ;

#pragma pack(pop)

// class ----------------------------------------

// A[JCuNX
class DXArchive
{
public :
	// t̔r
	enum DATE_RESULT
	{
		DATE_RESULT_LEFTNEW = 0,		// V
		DATE_RESULT_RIGHTNEW,			// V
		DATE_RESULT_DRAW,				// t͓
	} ;

	DXArchive( char *ArchivePath = NULL ) ;
	~DXArchive() ;

	static int			EncodeArchive( char *OutputFileName, char **FileOrDirectoryPath, int FileNum, bool Press = false, const char *KeyString = NULL ) ;	// A[JCut@C쐬
	static int			EncodeArchiveOneDirectory( char *OutputFileName, char *FolderPath, bool Press = false, const char *KeyString = NULL ) ;		// A[JCut@C쐬(fBNg)
	static int			DecodeArchive( char *ArchiveName, char *OutputPath, const char *KeyString = NULL ) ;								// A[JCut@CWJ

	int					OpenArchiveFile( const char *ArchivePath, const char *KeyString = NULL ) ;				// A[JCut@CJ( 0:  -1:s )
	int					OpenArchiveFileMem( const char *ArchivePath, const char *KeyString = NULL ) ;			// A[JCut@CJŏɂׂăɓǂݍł珈( 0:  -1:s )
	int					OpenArchiveMem( void *ArchiveImage, s64 ArchiveSize, const char *KeyString = NULL ) ;	// ɂA[JCut@CC[WJ( 0:  -1:s )
	int					CloseArchiveFile( void ) ;																// A[JCut@C

	s64					LoadFileToMem( const char *FilePath, void *Buffer, u64 BufferLength ) ;		// A[JCut@C̎w̃t@Cɓǂݍ( -1:G[ 0ȏ:t@CTCY )
	s64					GetFileSize( const char *FilePath ) ;										// A[JCut@C̎w̃t@CTCY擾( -1:G[ )
	int					GetFileInfo( const char *FilePath, u64 *PositionP, u64 *SizeP ) ;			// A[JCut@C̎w̃t@C̃t@C̈ʒuƃt@C̑傫𓾂( -1:G[ )
	void				*GetFileImage( void ) ;														// A[JCut@Cɓǂݍ񂾏ꍇ̃t@CC[Wi[Ă擪AhX擾( JĂꍇ̂ݗLAkĂꍇ́AkꂽԂ̃f[^i[Ă̂Œ )
	class DXArchiveFile *OpenFile( const char *FilePath ) ;											// A[JCut@C̎w̃t@CJAt@CANZXpIuWFNg쐬( t@CJĂꍇ̂ݗL )

	void *				LoadFileToCash( const char *FilePath ) ;									// A[JCut@C̎w̃t@CANX̃LbVobt@ɓǂݍ
	void *				GetCash( void ) ;															// LbVobt@̃AhX擾
	int					ClearCash( void ) ;															// LbVobt@J

	int					ChangeCurrentDir( const char *DirPath ) ;									// A[JCũfBNgpXύX( 0:  -1:s )
	int					GetCurrentDir( char *DirPathBuffer, int BufferLength ) ;					// A[JCũJgfBNgpX擾



	// ȉ͊ƓŎgp
	static void fwrite64( void *Data, s64 Size, FILE *fp ) ;						// WXg[Ƀf[^( 64bit )
	static void fread64( void *Buffer, s64 Size, FILE *fp ) ;						// WXg[f[^ǂݍ( 64bit )
	static void NotConv( void *Data , s64 Size ) ;									// f[^𔽓]֐
	static void NotConvFileWrite( void *Data, s64 Size, FILE *fp ) ;				// f[^𔽓]ăt@Cɏo֐
	static void NotConvFileRead( void *Data, s64 Size, FILE *fp ) ;					// f[^𔽓]ăt@Cǂݍފ֐
	static void KeyCreate( const char *Source, unsigned char *Key ) ;				// 쐬
	static void KeyConv( void *Data, s64 Size, s64 Position, unsigned char *Key ) ;	// gp Xor Z( Key ͕K DXA_KEYSTR_LENGTH ̒Ȃ΂ȂȂ )
	static void KeyConvFileWrite( void *Data, s64 Size, FILE *fp, unsigned char *Key, s64 Position = -1 ) ;	// f[^gp Xor Zt@Cɏo֐( Key ͕K DXA_KEYSTR_LENGTH ̒Ȃ΂ȂȂ )
	static void KeyConvFileRead( void *Data, s64 Size, FILE *fp, unsigned char *Key, s64 Position = -1 ) ;	// t@Cǂݍ񂾃f[^gp Xor Z֐( Key ͕K DXA_KEYSTR_LENGTH ̒Ȃ΂ȂȂ )
	static DATE_RESULT DateCmp( DARC_FILETIME *date1, DARC_FILETIME *date2 ) ;		// ǂ炪Vr
	static int Encode( void *Src, u32 SrcSize, void *Dest ) ;						// f[^k( ߂l:k̃f[^TCY )
	static int Decode( void *Src, void *Dest ) ;									// f[^𓀂( ߂l:𓀌̃f[^TCY )

	DARC_DIRECTORY *GetCurrentDirectoryInfo( void ) ;									// A[JCũJgfBNg̏擾
	DARC_FILEHEAD *GetFileInfo( const char *FilePath ) ;							// t@C̏𓾂
	inline DARC_HEAD *GetHeader( void ){ return &Head ; }
	inline u8 *GetKey( void ){ return Key ; }
	inline FILE *GetFilePointer( void ){ return fp ; }
	inline u8 *GetNameP( void ){ return NameP ; }

protected :
	FILE *fp ;							// A[JCut@C̃|C^	
	u8 *HeadBuffer ;					// wb_[obt@[
	u8 *FileP, *DirP, *NameP ;			// ee[u(t@Cwb_e[uAfBNge[uAOe[u)ւ̃|C^
	DARC_DIRECTORY *CurrentDirectory ;	// JgfBNgf[^ւ̃|C^

	void *CashBuffer ;					// ǂݍ񂾃t@Cf[^ꎞIɕۑĂobt@
	u64 CashBufferSize ;				// LbVobt@ɊmۂĂ郁e
	bool MemoryOpenFlag ;				// ̃t@CJĂ邩AtO
	bool UserMemoryImageFlag ;			// [U[WJC[WgpĂ邩AtO
	s64 MemoryImageSize ;				// ̃t@CJĂꍇ̃C[W̃TCY
	u8 Key[DXA_KEYSTR_LENGTH] ;			// 

	DARC_HEAD Head ;					// A[JCũwb_

	// TCYۑp\
	typedef struct tagSIZESAVE
	{
		u64 DataSize ;			// f[^̑
		u64 NameSize ;			// t@Cf[^̑
		u64 DirectorySize ;		// fBNgf[^̑
		u64 FileSize ;			// t@CvpeBf[^̑
	} SIZESAVE ;

	// t@Cpf[^\
	typedef struct tagSEARCHDATA
	{
		u8 FileName[1024] ;
		u16 Parity ;
		u16 PackNum ;
	} SEARCHDATA ;

	static int DirectoryEncode( char *DirectoryName, u8 *NameP, u8 *DirP, u8 *FileP, DARC_DIRECTORY *ParentDir, SIZESAVE *Size, int DataNumber, FILE *DestP, void *TempBuffer, bool Press, unsigned char *Key ) ;	// w̃fBNgɂt@CA[JCuf[^ɓfo
	static int DirectoryDecode( u8 *NameP, u8 *DirP, u8 *FileP, DARC_HEAD *Head, DARC_DIRECTORY *Dir, FILE *ArcP, unsigned char *Key ) ;											// w̃fBNgf[^ɂt@CWJ
	static int StrICmp( const char *Str1, const char *Str2 ) ;							// rΏƂ̕񒆂̑啶ƂĈr( 0:  1:Ⴄ )
	static int ConvSearchData( SEARCHDATA *Dest, const char *Src, int *Length ) ;		// p̃f[^ɕϊ( k \ I )
	static int AddFileNameData( const char *FileName, u8 *FileNameTable ) ;				// t@Cf[^ǉ( ߂l͎gpf[^oCg )
	static const char *GetOriginalFileName( u8 *FileNameTable ) ;						// t@Cf[^猳̃t@C̕擾
	static int GetDirectoryFilePath( const char *DirectoryPath, char *FilePathBuffer = NULL ) ;	// fBNg̃t@C̃pX擾( FilePathBuffer ͈t@Cɕt256oCg̗eʂKv )
	int	ChangeCurrentDirectoryFast( SEARCHDATA *SearchData ) ;							// A[JCũfBNgpXύX( 0:  -1:s )
	int	ChangeCurrentDirectoryBase( const char *DirectoryPath, bool ErrorIsDirectoryReset, SEARCHDATA *LastSearchData = NULL ) ;		// A[JCũfBNgpXύX( 0:  -1:s )
	int DirectoryKeyConv( DARC_DIRECTORY *Dir ) ;										// w̃fBNgf[^̈Í( ۂƃɓǂݍ񂾏ꍇp )

	// QoCgׂ( TRUE:QoCg FALSE:PoCg )
	inline static int CheckMultiByteChar( const char *Buf )
	{
		return  ( (unsigned char)*Buf >= 0x81 && (unsigned char)*Buf <= 0x9F ) || ( (unsigned char)*Buf >= 0xE0 && (unsigned char)*Buf <= 0xFC ) ;
	}

	// t@CꏏɂȂĂƕĂpXt@CpXƃfBNgpX𕪊
	// tpXłKv͖
	static int GetFilePathAndDirPath( char *Src, char *FilePath, char *DirPath ) ;
} ;


// A[JCuꂽt@C̃ANZXp̃NX
class DXArchiveFile
{
protected :
	DARC_FILEHEAD *FileData ;		// t@Cf[^ւ̃|C^
	DXArchive *Archive ;			// A[JCuNXւ̃|C^
	void *DataBuffer ;				// Ƀf[^WJۂ̃obt@̃|C^

	int EOFFlag ;					// EOFtO
	u64 FilePoint ;					// t@C|C^

public :
	DXArchiveFile( DARC_FILEHEAD *FileHead, DXArchive *Archive ) ;
	~DXArchiveFile() ;

	s64 Read( void *Buffer, s64 ReadLength ) ;					// t@C̓eǂݍ
	s64 Seek( s64 SeekPoint, s64 SeekMode ) ;					// t@C|C^ύX
	s64 Tell( void ) ;											// ݂̃t@C|C^𓾂
	s64 Eof( void ) ;											// t@C̏I[ɗĂ邩ÃtO𓾂
	s64 Size( void ) ;											// t@C̃TCY擾

	inline DARC_FILEHEAD *GetFileData( void ){ return FileData ; }
} ;

#endif

